#!/system/bin/sh

echo "2048,3072,6144,15360,17920,20480" > /sys/module/lowmemorykiller/parameters/minfree

echo "0" > /proc/sys/net/ipv4/tcp_timestamps
echo "1" > /proc/sys/net/ipv4/tcp_tw_reuse
echo "1" > /proc/sys/net/ipv4/tcp_sack
echo "1" > /proc/sys/net/ipv4/tcp_tw_recycle
echo "1" > /proc/sys/net/ipv4/tcp_window_scaling
echo "5" > /proc/sys/net/ipv4/tcp_keepalive_probes
echo "30" > /proc/sys/net/ipv4/tcp_keepalive_intvl
echo "30" > /proc/sys/net/ipv4/tcp_fin_timeout
echo "404480" > /proc/sys/net/core/wmem_max
echo "404480" > /proc/sys/net/core/rmem_max
echo "256960" > /proc/sys/net/core/rmem_default
echo "256960" > /proc/sys/net/core/wmem_default
echo "4096,16384,404480" > /proc/sys/net/ipv4/tcp_wmem
echo "4096,87380,404480" > /proc/sys/net/ipv4/tcp_rmem

echo "4096" > /proc/sys/vm/min_free_kbytes
echo "0" > /proc/sys/vm/oom_kill_allocating_task
echo "0" > /proc/sys/vm/panic_on_oom
echo "0" > /proc/sys/vm/laptop_mode
echo "0" > /proc/sys/vm/swappiness
echo "50" > /proc/sys/vm/vfs_cache_pressure
echo "90" > /proc/sys/vm/dirty_ratio
echo "70" > /proc/sys/vm/dirty_background_ratio

echo "8" > /proc/sys/vm/page-cluster
echo "64000" > /proc/sys/kernel/msgmni
echo "64000" > /proc/sys/kernel/msgmax
echo "10" > /proc/sys/fs/lease-break-time
echo "500,512000,64,2048" > /proc/sys/kernel/sem

echo "500" > /proc/sys/vm/dirty_expire_centisecs
echo "1000" > /proc/sys/vm/dirty_writeback_centisecs

#LOOP=`ls -d /sys/block/loop*`;
#RAM=`ls -d /sys/block/ram*`;
#MMC=`ls -d /sys/block/mmc*`;
#for j in $LOOP $RAM
#do
#echo "0" > $j/queue/rotational
#echo "2048" > $j/queue/read_ahead_kb
#done

echo "2048" > /sys/devices/virtual/bdi/179:0/read_ahead_kb

for i in \
`find /data -iname "*.db"`
do \
sqlite3 $i 'VACUUM;'; 
done

SAMPLING_RATE=$(busybox expr `cat /sys/devices/system/cpu/cpu0/cpufreq/cpuinfo_transition_latency` \* 750 / 1000)
echo 95 > /sys/devices/system/cpu/cpufreq/ondemand/up_threshold
echo $SAMPLING_RATE > /sys/devices/system/cpu/cpu0/cpufreq/ondemand/sampling_rate

echo "vr" > /sys/block/mmcblk0/queue/scheduler
echo "governor-name-here" > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor

CACHESIZE=$(df -k /cache | tail -n1 | tr -s ' ' | cut -d ' ' -f2)
if [ $CACHESIZE -gt 80000 ]
	then
	echo "Large cache detected, moving dalvik-cache to /cache"
	if [ ! -d /cache/dalvik-cache ]
		then
		busybox rm -rf /cache/dalvik-cache /data/dalvik-cache
		mkdir /cache/dalvik-cache /data/dalvik-cache
		fi

	busybox chown 1000:1000 /cache/dalvik-cache
	busybox chmod 0771 /cache/dalvik-cache

	# bind mount dalvik-cache so we can still boot without the sdcard
	busybox mount -o bind /cache/dalvik-cache /data/dalvik-cache
	busybox chown 1000:1000 /data/dalvik-cache
	busybox chmod 0771 /data/dalvik-cache
	else
	echo "Small cache detected, dalvik-cache will remain on /data"
fi










